function [v_out] = MatrixVecMult(varargin)

if length(varargin) == 2
    M_in = varargin{1};
    v_in= varargin{2};
    type = 'normal';
elseif length(varargin) == 3
    M_in = varargin{1};
    v_in= varargin{2};
    type = varargin{3};
end
v_out = zeros(size(v_in));

if size(M_in,2)~=size(v_in,1)
    error('Absorber:WrongMxSizes','Error!')
elseif size(M_in,3)~=size(v_in,2)
    error('Absorber:WrongMxSizes2','Incorrect dimensions for matrix multiplication!')
end
for n = 1 : size(M_in,3)
    switch type
        case 'normal'
            v_out(:,n) = squeeze(M_in(:,:,n))*squeeze(v_in(:,n));
        case 'inv'
            Min = squeeze(M_in(:,:,n));
            Min(isnan(Min)) = 0;
            v_out(:,n) = pinv(Min)*squeeze(v_in(:,n));
    end
end

end
