classdef air_layer < layer
    %FLUID_LAYER Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        thickness
    end
    
    methods
        function obj = air_layer(id,material,thickness)
            obj = obj@layer(id, material);
            obj.thickness = thickness;
            obj.type = 'air';
        end
        
        function calculate_acoustic_properties(obj,env,f)
            obj.wavenumber = 2*pi*f./env.get_speedofsound;
            obj.specific_impedance = env.get_impedance;
        end
        
        function calculate_transfer_matrix(obj,fi0)
            d = obj.thickness;
            Z0 = reshape(obj.specific_impedance,[1,1,length(obj.specific_impedance)]);
            kz = reshape(obj.wavenumber*cos(fi0),[1,1,length(obj.wavenumber)]);
            obj.transfer_mx = [ cos(kz.*d),               1i*Z0.*sin(kz.*d)./cos(fi0);
                1i*sin(kz.*d).*cos(fi0)./Z0,      cos(kz.*d)];
        end

    end
end

