classdef limp_membrane_layer < layer
    %LIMP_MEMBRANE_LAYER Summary of this class goes here
    %   Detailed explanation goes here
    properties (SetAccess = private)
        mass
    end
    
    methods
        function obj = limp_membrane_layer(id, material, mass)
            %LIMP_MEMBRANE_LAYER Construct an instance of this class
            %   Detailed explanation goes here
            obj = obj@layer(id, material);
            obj.type = 'limp_membrane';
            obj.mass = mass;
        end
        
        function calculate_acoustic_properties(obj,env,f)
            obj.wavenumber = 2*pi*f/env.get_speedofsound;
            rs = 1e10;
%            obj.specific_impedance = obj.ks./(1i*2*pi*f) + 1i*(2*pi*f).*obj.thickness.*obj.stiffness;
            obj.specific_impedance = 1i*2*pi*f*obj.mass*rs./(rs + 1i*2*pi*f*obj.mass);
        end
        
        function obj = calculate_transfer_matrix(obj, fi0)
            Z0 = reshape(obj.specific_impedance,[1,1,length(obj.specific_impedance)]);
            obj.transfer_mx = [ones(1,1,length(Z0)), Z0;
                               zeros(1,1,length(Z0)),ones(1,1,length(Z0))];
        end

    end
end

