
clear
close all

env = environment;

%%
absorber_1 = multilayered_absorber(env);
% Limp membrane: material, mass per area
%absorber_1.add_layer('limp_membrane',1);

% Perforated_panel: thickness, hole spacing, hole radius
%absorber_1.add_layer('perforated_panel',1e-2,20e-3,5e-3);

% Perforated_panel: thickness, slot spacing, slot width
%absorber_1.add_layer('slotted_panel',1e-2,20e-3,5e-3);

% Porous layer: material, thickness, flow resistivity, model
absorber_1.add_layer('porous',10e-2,10e3,'delany'); 

% Air layer: material, thickness
%absorber_1.add_layer('air',5e-2);

absorber_1.add_layer('rigid_termination');


%%

load('2021_12_009.mat');
%%

fs = Result.AcqSetup.Fs;
Ns = Result.AcqSetup.nSamples;

h_5 = Result.ImpulseResponse(:,1);
h_15 = Result.ImpulseResponse(:,2);

%h_25(550:end) = 0;
%h_55(550:end) = 0;

H_5 = fft(h_5);
H_15 = fft(h_15);

Nfilt = length(H_5);
freq = (0:Nfilt-1)'/Nfilt*fs;

w = 2*pi*freq;
k = w / 343.1;

H12 = H_15./H_5;
z1 = 5e-3;
z2 = 15e-3;

R = ( H12.*exp(1i*k*z1) - exp(1i*k*z2) )./( exp(-1i*k*z2) - H12.*exp(-1i*k*z1) );

alpha_measured = 1 - abs(R).^2;
Z = 1.2*343.1*(1+R)./(1-R);


fi0 = 0;

R = absorber_1.calculate_reflection_coefficient(fi0,freq);
alpha_theoretical = absorber_1.calculate_absorption_coefficient(fi0,freq);
%%
figure
%hold on
semilogx(freq,abs(alpha_measured))
hold on
semilogx(freq,alpha_theoretical);
xlim([60,10e3])
ylim([0,1])
grid on
xlabel('f -> [Hz]')
ylabel('\alpha -> []')
