classdef slotted_panel < layer
    %SLOTTED_PLATE Summary of this class goes here
    %   Detailed explanation goes here
    
    properties (SetAccess = private)
        thickness
        D    % repeat_distance / spacing
        w    % slot width
    end
    
    methods
        function obj = slotted_panel(id, material, thickness, D ,w)
            %LIMP_MEMBRANE_LAYER Construct an instance of this class
            %   Detailed explanation goes here
            obj = obj@layer(id, material);
            obj.type = 'slotted_panel';
            obj.thickness = thickness;
            obj.D = D;
            obj.w = w;
        end
        
        function calculate_acoustic_properties(obj,env,f)
            obj.wavenumber = 2*pi*f/env.get_speedofsound;
            eps = obj.w / obj.D;
            v = 15e-6;
            delta = -1/pi*log(sin(0.5*pi*eps));
            m = env.get_density/eps*( obj.thickness + 2*delta*obj.w );
            
            r = env.get_density/eps*sqrt(8*v*2*pi*f)*(1 + obj.thickness/obj.r);
            obj.specific_impedance = r + 1i*2*pi*f.*m;
        end
        
        function obj = calculate_transfer_matrix(obj, fi0)
            Z0 = reshape(obj.specific_impedance,[1,1,length(obj.specific_impedance)]);
            obj.transfer_mx = [ones(1,1,length(Z0)), Z0;
                               zeros(1,1,length(Z0)),ones(1,1,length(Z0))];
        end

    end
end

